#! /usr/bin/perl

$TabData = "DATA_TABLE" ;
$TypeName = "MyType" ;
$TypePrefix = "MyT_" ;
$TailStr = "" ; 

print "// -*- Mode: C++ -*-\n" ;
print "// \n" ;
print "// This file is generate by tab2h.pl .\n" ;
print "// Please edit the original file.\n" ;
print "// \n" ;

$idlenmax = 0 ;
$strlenmax = 0 ;

while(<>) {
    if(/^\/\//) { print ; next ; }
    if(($tmp) = /^\:DATATAB\s*\=\s*([A-Za-z0-9_]+)/) {
	$TabData = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:TYPENAME\s*\=\s*([A-Za-z0-9_]+)/) {
	$TypeName = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:TYPEPREFIX\s*\=\s*([A-Za-z0-9_]+)/) {
	$TypePrefix = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:INSERT\s*([^\s]+)/) {
	$EndMark = $tmp ;
	while(<>) {
	    /$EndMark/ && do { last ; } ;
	    print ;
	} ;
    } ;
    if(($tmp) = /^\:TAIL\s*([^\s]+)/){ 
	$EndMark = $tmp ;
	while(<>) {
	    /$EndMark/ && do { last ; } ;
	    $TailStr .= $_ ;
	} ;
    }
#    if(/^\"/) {
#	chop ;
#	($name,$rest) = /^(\".*\")\s*(.*)$/ ;
#	$name =~ s/\"//g ;
#	push(@namelist, $name) ;
#	push(@restlist, $rest) ;
#    } ;

    if (($id,$str,$rest) = /^\s*([^\s]+)\s+(\"[^\"]+\")\s+(.*)$/) {
	push(@id, $id) ;
	push(@str,$str) ;
	push(@rest,$rest) ;
	if($idlenmax < length($id)) { $idlenmax = length($id) ; } ;
	if($strlenmax < length($str)) { $strlenmax = length($str) ; } ;
    } ;
}

$idlenmax += length($TypePrefix)+1 ;
$strlenmax++ ;

printf "enum %s \{\n",$TypeName ;
for($i = 0 ; $i <= $#id ; $i++) {
    $id = $id[$i] ;
    printf "\t%s%s,\n",$TypePrefix,$id ;
} ;
printf "\t%s\_MAX\n\} ;\n", $TypePrefix ;

printf "\n#define %s\t\{\\\n",$TabData ;
for($i = 0 ; $i <= $#id ; $i++) {
    $id = $TypePrefix.$id[$i] ;
    $str = $str[$i] ;
    $rest = $rest[$i] ;
    if($rest) {
	printf "  \{%-${idlenmax}s, %-${strlenmax}s, %s\},\\\n", $id,$str,$rest ;

    } else {
	printf "  \{%-${idlenmax}s, %-${strlenmax}s\},\\\n", $id, $str ;
    } ;
} ;
printf "  \{%s\_MAX, ITK_NULLPTR \}\}\n",$TypePrefix ;

if($TailStr) {
    print "\n\n" ;
    print $TailStr ;
}



    

