// -*- Mode:C++ -*-
//Header:
//File: chagamma.cc
//Title: BunChagama
//Author: NODA, Itsuki
//Date: 2001/04/20
//

//ModifyHistory:
// 2001/04/20: Start to create this file
//EndModifyHistory:


#include "Bun.h"

#define _INCLUDE_BODY_
# include "Config.h"
#undef _INCLUDE_BODY_

using namespace Soccer ;
using namespace Itk ;

//======================================================================
// run Offline Coach

int runOfflineCoach(int argc, char** argv) {
   OfflineCoach coach ;
   Bool r = coach.init(SHost,OffCoachPort,7.0,True) ;
   ITK_DBG(r) ;

   coach.forkSensor() ;

   coach.sendEye(True) ;
   coach.sendEar(True) ;
   coach.sendChangeMode(PLAYMODE(BeforeKickOff)) ;
   
   coach.cvSensor.lock() ;
   while(True) {
      coach.cvSensor.wait() ;
      ITK_MSG(TimeVal::now()) ;
      ITK_DBG(coach.recvsexp) ;
   }

   
   return 0 ;
} ;

//======================================================================
// play Bun

int playBun(int argc, char** argv) {
   Bun player ;

   // for test (Kalman Filter)
   //ITK_DSC(player.kfilter.wPf()) ;
   //player.kfilter.testRun() ;
   ///   return 0 ;
   
   player.run() ;

   return 0 ;
 
} ;

//======================================================================
// main

int main(int argc, char** argv) {
   getopt(argc,argv) ;

   playBun(argc,argv) ;
   //runOfflineCoach(argc,argv) ;

   return 0 ;
} ;



