// -*- Mode: C++ -*-
// 
// This file is generate by tab2h.pl .
// Please edit the original file.
// 
#define SC_HALF_PITCH_L		SC_PITCH_LENGTH/2.0 
#define SC_HALF_PITCH_W		SC_PITCH_WIDTH/2.0 
#define SC_PENALTY_CORNER_X	(SC_HALF_PITCH_L - SC_PENALTY_AREA_LENGTH)
#define SC_PENALTY_CORNER_Y	(SC_PENALTY_AREA_WIDTH/2.0)
#define SC_HALF_PITCH_L_M	(SC_HALF_PITCH_L + 5)
#define SC_HALF_PITCH_W_M	(SC_HALF_PITCH_W + 5)
enum LandmarkID {
	LMID_C,
	LMID_GL,
	LMID_GR,
	LMID_LT,
	LMID_LB,
	LMID_RT,
	LMID_RB,
	LMID_CT,
	LMID_CB,
	LMID_PLT,
	LMID_PLC,
	LMID_PLB,
	LMID_PRT,
	LMID_PRC,
	LMID_PRB,
	LMID_GLT,
	LMID_GLB,
	LMID_GRT,
	LMID_GRB,
	LMID_LT30,
	LMID_LT20,
	LMID_LT10,
	LMID_L0,
	LMID_LB10,
	LMID_LB20,
	LMID_LB30,
	LMID_RT30,
	LMID_RT20,
	LMID_RT10,
	LMID_R0,
	LMID_RB10,
	LMID_RB20,
	LMID_RB30,
	LMID_TL50,
	LMID_TL40,
	LMID_TL30,
	LMID_TL20,
	LMID_TL10,
	LMID_T0,
	LMID_TR10,
	LMID_TR20,
	LMID_TR30,
	LMID_TR40,
	LMID_TR50,
	LMID_BL50,
	LMID_BL40,
	LMID_BL30,
	LMID_BL20,
	LMID_BL10,
	LMID_B0,
	LMID_BR10,
	LMID_BR20,
	LMID_BR30,
	LMID_BR40,
	LMID_BR50,
	LMID_LineT,
	LMID_LineB,
	LMID_LineL,
	LMID_LineR,
	LMID_Unknown,
	LMID__MAX
} ;

#define LANDMARK_TABLE	{\
  {LMID_C       , "c"       , Pos(              0.0,                0.0)},\
  {LMID_GL      , "g l"     , Pos(    -SC_HALF_PITCH_L,             0.0)},\
  {LMID_GR      , "g r"     , Pos(     SC_HALF_PITCH_L,             0.0)},\
  {LMID_LT      , "l t"     , Pos(    -SC_HALF_PITCH_L,      -SC_HALF_PITCH_W) },\
  {LMID_LB      , "l b"     , Pos(    -SC_HALF_PITCH_L,       SC_HALF_PITCH_W) },\
  {LMID_RT      , "r t"     , Pos(     SC_HALF_PITCH_L,      -SC_HALF_PITCH_W) },\
  {LMID_RB      , "r b"     , Pos(     SC_HALF_PITCH_L,       SC_HALF_PITCH_W) },\
  {LMID_CT      , "c t"     , Pos(              0.0,      -SC_HALF_PITCH_W) },\
  {LMID_CB      , "c b"     , Pos(              0.0,       SC_HALF_PITCH_W) },\
  {LMID_PLT     , "p l t"   , Pos(-SC_PENALTY_CORNER_X,  -SC_PENALTY_CORNER_Y) },\
  {LMID_PLC     , "p l c"   , Pos(-SC_PENALTY_CORNER_X,                0.0) },\
  {LMID_PLB     , "p l b"   , Pos(-SC_PENALTY_CORNER_X,   SC_PENALTY_CORNER_Y) },\
  {LMID_PRT     , "p r t"   , Pos( SC_PENALTY_CORNER_X,  -SC_PENALTY_CORNER_Y) },\
  {LMID_PRC     , "p r c"   , Pos( SC_PENALTY_CORNER_X,                0.0) },\
  {LMID_PRB     , "p r b"   , Pos( SC_PENALTY_CORNER_X,   SC_PENALTY_CORNER_Y) },\
  {LMID_GLT     , "g l t"   , Pos(    -SC_HALF_PITCH_L,    -SC_GOAL_WIDTH/2.0)},\
  {LMID_GLB     , "g l b"   , Pos(    -SC_HALF_PITCH_L,     SC_GOAL_WIDTH/2.0)},\
  {LMID_GRT     , "g r t"   , Pos(     SC_HALF_PITCH_L,    -SC_GOAL_WIDTH/2.0)},\
  {LMID_GRB     , "g r b"   , Pos(     SC_HALF_PITCH_L,     SC_GOAL_WIDTH/2.0)},\
  {LMID_LT30    , "l t 30"  , Pos(  -SC_HALF_PITCH_L_M,                -30)},\
  {LMID_LT20    , "l t 20"  , Pos(  -SC_HALF_PITCH_L_M,                -20)},\
  {LMID_LT10    , "l t 10"  , Pos(  -SC_HALF_PITCH_L_M,                -10)},\
  {LMID_L0      , "l 0"     , Pos(  -SC_HALF_PITCH_L_M,                  0)},\
  {LMID_LB10    , "l b 10"  , Pos(  -SC_HALF_PITCH_L_M,                 10)},\
  {LMID_LB20    , "l b 20"  , Pos(  -SC_HALF_PITCH_L_M,                 20)},\
  {LMID_LB30    , "l b 30"  , Pos(  -SC_HALF_PITCH_L_M,                 30)},\
  {LMID_RT30    , "r t 30"  , Pos(   SC_HALF_PITCH_L_M,                -30)},\
  {LMID_RT20    , "r t 20"  , Pos(   SC_HALF_PITCH_L_M,                -20)},\
  {LMID_RT10    , "r t 10"  , Pos(   SC_HALF_PITCH_L_M,                -10)},\
  {LMID_R0      , "r 0"     , Pos(   SC_HALF_PITCH_L_M,                  0)},\
  {LMID_RB10    , "r b 10"  , Pos(   SC_HALF_PITCH_L_M,                 10)},\
  {LMID_RB20    , "r b 20"  , Pos(   SC_HALF_PITCH_L_M,                 20)},\
  {LMID_RB30    , "r b 30"  , Pos(   SC_HALF_PITCH_L_M,                 30)},\
  {LMID_TL50    , "t l 50"  , Pos(              -50,    -SC_HALF_PITCH_W_M)},\
  {LMID_TL40    , "t l 40"  , Pos(              -40,    -SC_HALF_PITCH_W_M)},\
  {LMID_TL30    , "t l 30"  , Pos(              -30,    -SC_HALF_PITCH_W_M)},\
  {LMID_TL20    , "t l 20"  , Pos(              -20,    -SC_HALF_PITCH_W_M)},\
  {LMID_TL10    , "t l 10"  , Pos(              -10,    -SC_HALF_PITCH_W_M)},\
  {LMID_T0      , "t 0"     , Pos(                0,    -SC_HALF_PITCH_W_M)},\
  {LMID_TR10    , "t r 10"  , Pos(               10,    -SC_HALF_PITCH_W_M)},\
  {LMID_TR20    , "t r 20"  , Pos(               20,    -SC_HALF_PITCH_W_M)},\
  {LMID_TR30    , "t r 30"  , Pos(               30,    -SC_HALF_PITCH_W_M)},\
  {LMID_TR40    , "t r 40"  , Pos(               40,    -SC_HALF_PITCH_W_M)},\
  {LMID_TR50    , "t r 50"  , Pos(               50,    -SC_HALF_PITCH_W_M)},\
  {LMID_BL50    , "b l 50"  , Pos(              -50,     SC_HALF_PITCH_W_M)},\
  {LMID_BL40    , "b l 40"  , Pos(              -40,     SC_HALF_PITCH_W_M)},\
  {LMID_BL30    , "b l 30"  , Pos(              -30,     SC_HALF_PITCH_W_M)},\
  {LMID_BL20    , "b l 20"  , Pos(              -20,     SC_HALF_PITCH_W_M)},\
  {LMID_BL10    , "b l 10"  , Pos(              -10,     SC_HALF_PITCH_W_M)},\
  {LMID_B0      , "b 0"     , Pos(                0,     SC_HALF_PITCH_W_M)},\
  {LMID_BR10    , "b r 10"  , Pos(               10,     SC_HALF_PITCH_W_M)},\
  {LMID_BR20    , "b r 20"  , Pos(               20,     SC_HALF_PITCH_W_M)},\
  {LMID_BR30    , "b r 30"  , Pos(               30,     SC_HALF_PITCH_W_M)},\
  {LMID_BR40    , "b r 40"  , Pos(               40,     SC_HALF_PITCH_W_M)},\
  {LMID_BR50    , "b r 50"  , Pos(               50,     SC_HALF_PITCH_W_M)},\
  {LMID_LineT   , "line t"  , Pos(                0,    -SC_HALF_PITCH_W)},\
  {LMID_LineB   , "line b"  , Pos(                0,     SC_HALF_PITCH_W)},\
  {LMID_LineL   , "line l"  , Pos( -SC_HALF_PITCH_L,                0.0)},\
  {LMID_LineR   , "line r"  , Pos(  SC_HALF_PITCH_L,                0.0)},\
  {LMID_Unknown , "unknown" , Pos(              0.0,                0.0) },\
  {LMID__MAX, ITK_NULLPTR }}


class Landmark {
   public:
      LandmarkID id ;
      char* namestr ;
      Pos pos ;
} ;

inline ostream & operator<< (ostream & ostr, const Landmark & l) {
      if (isNull(&l)) return ostr << (void *)ITK_NULLPTR ;
      else return ostr << "#Landmark[" << l.id 
	               << ":\"" << l.namestr 
	               << "\"@" << l.pos << "]" ;
} ;

